#include "game.h"
#include <raylib.h>

// Handle input for snake movement
void HandleInput(Snake *snake) {
    if (IsKeyPressed(KEY_RIGHT) && snake->direction.x != -1) {
        snake->direction.x = 1; 
        snake->direction.y = 0;
    }
    else if (IsKeyPressed(KEY_LEFT) && snake->direction.x != 1) {
        snake->direction.x = -1; 
        snake->direction.y = 0;
    }
    else if (IsKeyPressed(KEY_UP) && snake->direction.y != 1) {
        snake->direction.x = 0; 
        snake->direction.y = -1;
    }
    else if (IsKeyPressed(KEY_DOWN) && snake->direction.y != -1) {
        snake->direction.x = 0; 
        snake->direction.y = 1;
    }
}

// Restart game when Enter key is pressed
void ResetGame(Snake *snake, Food *food, int *score, bool *gameOver) {
    InitSnake(snake);
    SpawnFood(food);
    *score = 0;
    *gameOver = false;
}
